"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from datetime import datetime
from orq_ai_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from orq_ai_sdk.utils import (
    FieldMetadata,
    PathParamMetadata,
    RequestMetadata,
    parse_datetime,
)
import pydantic
from pydantic import model_serializer
from typing import Any, Dict, List, Literal, Optional, Union
from typing_extensions import Annotated, NotRequired, TypeAliasType, TypedDict


CreateDatasetItemMessagesDatasetsRequestRequestBody5Role = Literal["tool"]
r"""The role of the messages author, in this case tool."""

CreateDatasetItemMessagesDatasetsRequestContentTypedDict = TypeAliasType(
    "CreateDatasetItemMessagesDatasetsRequestContentTypedDict", Union[str, List[str]]
)
r"""The contents of the tool message."""


CreateDatasetItemMessagesDatasetsRequestContent = TypeAliasType(
    "CreateDatasetItemMessagesDatasetsRequestContent", Union[str, List[str]]
)
r"""The contents of the tool message."""


class CreateDatasetItemMessagesToolMessageTypedDict(TypedDict):
    role: CreateDatasetItemMessagesDatasetsRequestRequestBody5Role
    r"""The role of the messages author, in this case tool."""
    content: CreateDatasetItemMessagesDatasetsRequestContentTypedDict
    r"""The contents of the tool message."""
    tool_call_id: str
    r"""Tool call that this message is responding to."""


class CreateDatasetItemMessagesToolMessage(BaseModel):
    role: CreateDatasetItemMessagesDatasetsRequestRequestBody5Role
    r"""The role of the messages author, in this case tool."""

    content: CreateDatasetItemMessagesDatasetsRequestContent
    r"""The contents of the tool message."""

    tool_call_id: str
    r"""Tool call that this message is responding to."""


CreateDatasetItem2DatasetsRequestRequestBodyMessages4Type = Literal["refusal"]
r"""The type of the content part."""


class CreateDatasetItem2RefusalContentPartTypedDict(TypedDict):
    type: CreateDatasetItem2DatasetsRequestRequestBodyMessages4Type
    r"""The type of the content part."""
    refusal: str
    r"""The refusal message generated by the model."""


class CreateDatasetItem2RefusalContentPart(BaseModel):
    type: CreateDatasetItem2DatasetsRequestRequestBodyMessages4Type
    r"""The type of the content part."""

    refusal: str
    r"""The refusal message generated by the model."""


CreateDatasetItem2DatasetsRequestRequestBodyMessagesType = Literal["text"]
r"""The type of the content part."""


class CreateDatasetItem2TextContentPartTypedDict(TypedDict):
    type: CreateDatasetItem2DatasetsRequestRequestBodyMessagesType
    r"""The type of the content part."""
    text: str
    r"""The text content."""


class CreateDatasetItem2TextContentPart(BaseModel):
    type: CreateDatasetItem2DatasetsRequestRequestBodyMessagesType
    r"""The type of the content part."""

    text: str
    r"""The text content."""


CreateDatasetItemContentDatasets2TypedDict = TypeAliasType(
    "CreateDatasetItemContentDatasets2TypedDict",
    Union[
        CreateDatasetItem2TextContentPartTypedDict,
        CreateDatasetItem2RefusalContentPartTypedDict,
    ],
)


CreateDatasetItemContentDatasets2 = TypeAliasType(
    "CreateDatasetItemContentDatasets2",
    Union[CreateDatasetItem2TextContentPart, CreateDatasetItem2RefusalContentPart],
)


CreateDatasetItemMessagesDatasetsContentTypedDict = TypeAliasType(
    "CreateDatasetItemMessagesDatasetsContentTypedDict",
    Union[str, List[CreateDatasetItemContentDatasets2TypedDict]],
)
r"""The contents of the assistant message. Required unless `tool_calls` or `function_call` is specified."""


CreateDatasetItemMessagesDatasetsContent = TypeAliasType(
    "CreateDatasetItemMessagesDatasetsContent",
    Union[str, List[CreateDatasetItemContentDatasets2]],
)
r"""The contents of the assistant message. Required unless `tool_calls` or `function_call` is specified."""


CreateDatasetItemMessagesDatasetsRequestRequestBodyRole = Literal["assistant"]
r"""The role of the messages author, in this case `assistant`."""


class CreateDatasetItemMessagesAudioTypedDict(TypedDict):
    r"""Data about a previous audio response from the model."""

    id: str
    r"""Unique identifier for a previous audio response from the model."""


class CreateDatasetItemMessagesAudio(BaseModel):
    r"""Data about a previous audio response from the model."""

    id: str
    r"""Unique identifier for a previous audio response from the model."""


CreateDatasetItemMessagesType = Literal["function"]
r"""The type of the tool. Currently, only `function` is supported."""


class CreateDatasetItemMessagesFunctionTypedDict(TypedDict):
    name: NotRequired[str]
    r"""The name of the function to call."""
    arguments: NotRequired[str]
    r"""The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function."""


class CreateDatasetItemMessagesFunction(BaseModel):
    name: Optional[str] = None
    r"""The name of the function to call."""

    arguments: Optional[str] = None
    r"""The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function."""


class CreateDatasetItemMessagesToolCallsTypedDict(TypedDict):
    id: str
    r"""The ID of the tool call."""
    type: CreateDatasetItemMessagesType
    r"""The type of the tool. Currently, only `function` is supported."""
    function: CreateDatasetItemMessagesFunctionTypedDict


class CreateDatasetItemMessagesToolCalls(BaseModel):
    id: str
    r"""The ID of the tool call."""

    type: CreateDatasetItemMessagesType
    r"""The type of the tool. Currently, only `function` is supported."""

    function: CreateDatasetItemMessagesFunction


class CreateDatasetItemMessagesAssistantMessageTypedDict(TypedDict):
    role: CreateDatasetItemMessagesDatasetsRequestRequestBodyRole
    r"""The role of the messages author, in this case `assistant`."""
    content: NotRequired[Nullable[CreateDatasetItemMessagesDatasetsContentTypedDict]]
    r"""The contents of the assistant message. Required unless `tool_calls` or `function_call` is specified."""
    refusal: NotRequired[Nullable[str]]
    r"""The refusal message by the assistant."""
    name: NotRequired[str]
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""
    audio: NotRequired[Nullable[CreateDatasetItemMessagesAudioTypedDict]]
    r"""Data about a previous audio response from the model."""
    tool_calls: NotRequired[List[CreateDatasetItemMessagesToolCallsTypedDict]]
    r"""The tool calls generated by the model, such as function calls."""
    reasoning: NotRequired[str]
    r"""Internal thought process of the model"""
    reasoning_signature: NotRequired[str]
    r"""The signature holds a cryptographic token which verifies that the thinking block was generated by the model, and is verified when thinking is part of a multiturn conversation. This value should not be modified and should always be sent to the API when the reasoning is redacted. Currently only supported by `Anthropic`."""
    redacted_reasoning: NotRequired[str]
    r"""Occasionally the model's internal reasoning will be flagged by the safety systems of the provider. When this occurs, the provider will encrypt the reasoning. These redacted reasoning is decrypted when passed back to the API, allowing the model to continue its response without losing context."""


class CreateDatasetItemMessagesAssistantMessage(BaseModel):
    role: CreateDatasetItemMessagesDatasetsRequestRequestBodyRole
    r"""The role of the messages author, in this case `assistant`."""

    content: OptionalNullable[CreateDatasetItemMessagesDatasetsContent] = UNSET
    r"""The contents of the assistant message. Required unless `tool_calls` or `function_call` is specified."""

    refusal: OptionalNullable[str] = UNSET
    r"""The refusal message by the assistant."""

    name: Optional[str] = None
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""

    audio: OptionalNullable[CreateDatasetItemMessagesAudio] = UNSET
    r"""Data about a previous audio response from the model."""

    tool_calls: Optional[List[CreateDatasetItemMessagesToolCalls]] = None
    r"""The tool calls generated by the model, such as function calls."""

    reasoning: Optional[str] = None
    r"""Internal thought process of the model"""

    reasoning_signature: Optional[str] = None
    r"""The signature holds a cryptographic token which verifies that the thinking block was generated by the model, and is verified when thinking is part of a multiturn conversation. This value should not be modified and should always be sent to the API when the reasoning is redacted. Currently only supported by `Anthropic`."""

    redacted_reasoning: Optional[str] = None
    r"""Occasionally the model's internal reasoning will be flagged by the safety systems of the provider. When this occurs, the provider will encrypt the reasoning. These redacted reasoning is decrypted when passed back to the API, allowing the model to continue its response without losing context."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "content",
            "refusal",
            "name",
            "audio",
            "tool_calls",
            "reasoning",
            "reasoning_signature",
            "redacted_reasoning",
        ]
        nullable_fields = ["content", "refusal", "audio"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


CreateDatasetItemMessagesDatasetsRequestRole = Literal["user"]
r"""The role of the messages author, in this case `user`."""

CreateDatasetItem2DatasetsRequestRequestBodyType = Literal["file"]
r"""The type of the content part. Always `file`."""


class CreateDatasetItem2FileTypedDict(TypedDict):
    file_data: str
    r"""The base64 encoded file data, used when passing the file to the model as a string."""
    filename: NotRequired[str]
    r"""The name of the file, used when passing the file to the model as a string."""


class CreateDatasetItem2File(BaseModel):
    file_data: str
    r"""The base64 encoded file data, used when passing the file to the model as a string."""

    filename: Optional[str] = None
    r"""The name of the file, used when passing the file to the model as a string."""


class CreateDatasetItem24TypedDict(TypedDict):
    type: CreateDatasetItem2DatasetsRequestRequestBodyType
    r"""The type of the content part. Always `file`."""
    file: CreateDatasetItem2FileTypedDict


class CreateDatasetItem24(BaseModel):
    type: CreateDatasetItem2DatasetsRequestRequestBodyType
    r"""The type of the content part. Always `file`."""

    file: CreateDatasetItem2File


CreateDatasetItem2DatasetsRequestType = Literal["input_audio"]

CreateDatasetItem2Format = Literal["mp3", "wav"]
r"""The format of the encoded audio data. Currently supports `wav` and `mp3`."""


class CreateDatasetItem2InputAudioTypedDict(TypedDict):
    data: str
    r"""Base64 encoded audio data."""
    format_: CreateDatasetItem2Format
    r"""The format of the encoded audio data. Currently supports `wav` and `mp3`."""


class CreateDatasetItem2InputAudio(BaseModel):
    data: str
    r"""Base64 encoded audio data."""

    format_: Annotated[CreateDatasetItem2Format, pydantic.Field(alias="format")]
    r"""The format of the encoded audio data. Currently supports `wav` and `mp3`."""


class CreateDatasetItem23TypedDict(TypedDict):
    type: CreateDatasetItem2DatasetsRequestType
    input_audio: CreateDatasetItem2InputAudioTypedDict


class CreateDatasetItem23(BaseModel):
    type: CreateDatasetItem2DatasetsRequestType

    input_audio: CreateDatasetItem2InputAudio


CreateDatasetItem2DatasetsType = Literal["image_url"]

CreateDatasetItem2Detail = Literal["low", "high", "auto"]
r"""Specifies the detail level of the image."""


class CreateDatasetItem2ImageURLTypedDict(TypedDict):
    url: str
    r"""Either a URL of the image or the base64 encoded image data."""
    detail: NotRequired[CreateDatasetItem2Detail]
    r"""Specifies the detail level of the image."""


class CreateDatasetItem2ImageURL(BaseModel):
    url: str
    r"""Either a URL of the image or the base64 encoded image data."""

    detail: Optional[CreateDatasetItem2Detail] = None
    r"""Specifies the detail level of the image."""


class CreateDatasetItem22TypedDict(TypedDict):
    type: CreateDatasetItem2DatasetsType
    image_url: CreateDatasetItem2ImageURLTypedDict


class CreateDatasetItem22(BaseModel):
    type: CreateDatasetItem2DatasetsType

    image_url: CreateDatasetItem2ImageURL


CreateDatasetItem2Type = Literal["text"]


class CreateDatasetItem21TypedDict(TypedDict):
    type: CreateDatasetItem2Type
    text: str


class CreateDatasetItem21(BaseModel):
    type: CreateDatasetItem2Type

    text: str


CreateDatasetItemContent2TypedDict = TypeAliasType(
    "CreateDatasetItemContent2TypedDict",
    Union[
        CreateDatasetItem21TypedDict,
        CreateDatasetItem22TypedDict,
        CreateDatasetItem23TypedDict,
        CreateDatasetItem24TypedDict,
    ],
)


CreateDatasetItemContent2 = TypeAliasType(
    "CreateDatasetItemContent2",
    Union[
        CreateDatasetItem21,
        CreateDatasetItem22,
        CreateDatasetItem23,
        CreateDatasetItem24,
    ],
)


CreateDatasetItemMessagesContentTypedDict = TypeAliasType(
    "CreateDatasetItemMessagesContentTypedDict",
    Union[str, List[CreateDatasetItemContent2TypedDict]],
)
r"""The contents of the user message."""


CreateDatasetItemMessagesContent = TypeAliasType(
    "CreateDatasetItemMessagesContent", Union[str, List[CreateDatasetItemContent2]]
)
r"""The contents of the user message."""


class CreateDatasetItemMessagesUserMessageTypedDict(TypedDict):
    role: CreateDatasetItemMessagesDatasetsRequestRole
    r"""The role of the messages author, in this case `user`."""
    content: CreateDatasetItemMessagesContentTypedDict
    r"""The contents of the user message."""
    name: NotRequired[str]
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


class CreateDatasetItemMessagesUserMessage(BaseModel):
    role: CreateDatasetItemMessagesDatasetsRequestRole
    r"""The role of the messages author, in this case `user`."""

    content: CreateDatasetItemMessagesContent
    r"""The contents of the user message."""

    name: Optional[str] = None
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


CreateDatasetItemMessagesDatasetsRole = Literal["system"]
r"""The role of the messages author, in this case `system`."""


class CreateDatasetItemMessagesSystemMessageTypedDict(TypedDict):
    role: CreateDatasetItemMessagesDatasetsRole
    r"""The role of the messages author, in this case `system`."""
    content: str
    r"""The contents of the system message."""
    name: NotRequired[str]
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


class CreateDatasetItemMessagesSystemMessage(BaseModel):
    role: CreateDatasetItemMessagesDatasetsRole
    r"""The role of the messages author, in this case `system`."""

    content: str
    r"""The contents of the system message."""

    name: Optional[str] = None
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


CreateDatasetItemMessagesRole = Literal["developer"]
r"""The role of the messages author, in this case  `developer`."""


class CreateDatasetItemMessagesDeveloperMessageTypedDict(TypedDict):
    role: CreateDatasetItemMessagesRole
    r"""The role of the messages author, in this case  `developer`."""
    content: str
    r"""The contents of the developer message."""
    name: NotRequired[str]
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


class CreateDatasetItemMessagesDeveloperMessage(BaseModel):
    role: CreateDatasetItemMessagesRole
    r"""The role of the messages author, in this case  `developer`."""

    content: str
    r"""The contents of the developer message."""

    name: Optional[str] = None
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


CreateDatasetItemMessagesTypedDict = TypeAliasType(
    "CreateDatasetItemMessagesTypedDict",
    Union[
        CreateDatasetItemMessagesDeveloperMessageTypedDict,
        CreateDatasetItemMessagesSystemMessageTypedDict,
        CreateDatasetItemMessagesUserMessageTypedDict,
        CreateDatasetItemMessagesToolMessageTypedDict,
        CreateDatasetItemMessagesAssistantMessageTypedDict,
    ],
)


CreateDatasetItemMessages = TypeAliasType(
    "CreateDatasetItemMessages",
    Union[
        CreateDatasetItemMessagesDeveloperMessage,
        CreateDatasetItemMessagesSystemMessage,
        CreateDatasetItemMessagesUserMessage,
        CreateDatasetItemMessagesToolMessage,
        CreateDatasetItemMessagesAssistantMessage,
    ],
)


class CreateDatasetItemRequestBodyTypedDict(TypedDict):
    inputs: NotRequired[Dict[str, Any]]
    r"""The inputs of the dataset. Key value pairs where the key is the input name and the value is the input value. Nested objects are not supported."""
    messages: NotRequired[List[CreateDatasetItemMessagesTypedDict]]
    r"""A list of messages comprising the conversation so far"""
    expected_output: NotRequired[str]


class CreateDatasetItemRequestBody(BaseModel):
    inputs: Optional[Dict[str, Any]] = None
    r"""The inputs of the dataset. Key value pairs where the key is the input name and the value is the input value. Nested objects are not supported."""

    messages: Optional[List[CreateDatasetItemMessages]] = None
    r"""A list of messages comprising the conversation so far"""

    expected_output: Optional[str] = None


class CreateDatasetItemRequestTypedDict(TypedDict):
    dataset_id: str
    request_body: NotRequired[CreateDatasetItemRequestBodyTypedDict]


class CreateDatasetItemRequest(BaseModel):
    dataset_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]

    request_body: Annotated[
        Optional[CreateDatasetItemRequestBody],
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ] = None


CreateDatasetItemMessagesDatasetsResponse200ApplicationJSONResponseBody5Role = Literal[
    "tool"
]
r"""The role of the messages author, in this case tool."""

CreateDatasetItemMessagesDatasetsResponse200ApplicationJSONContentTypedDict = (
    TypeAliasType(
        "CreateDatasetItemMessagesDatasetsResponse200ApplicationJSONContentTypedDict",
        Union[str, List[str]],
    )
)
r"""The contents of the tool message."""


CreateDatasetItemMessagesDatasetsResponse200ApplicationJSONContent = TypeAliasType(
    "CreateDatasetItemMessagesDatasetsResponse200ApplicationJSONContent",
    Union[str, List[str]],
)
r"""The contents of the tool message."""


class CreateDatasetItemMessagesDatasetsToolMessageTypedDict(TypedDict):
    role: CreateDatasetItemMessagesDatasetsResponse200ApplicationJSONResponseBody5Role
    r"""The role of the messages author, in this case tool."""
    content: CreateDatasetItemMessagesDatasetsResponse200ApplicationJSONContentTypedDict
    r"""The contents of the tool message."""
    tool_call_id: str
    r"""Tool call that this message is responding to."""


class CreateDatasetItemMessagesDatasetsToolMessage(BaseModel):
    role: CreateDatasetItemMessagesDatasetsResponse200ApplicationJSONResponseBody5Role
    r"""The role of the messages author, in this case tool."""

    content: CreateDatasetItemMessagesDatasetsResponse200ApplicationJSONContent
    r"""The contents of the tool message."""

    tool_call_id: str
    r"""Tool call that this message is responding to."""


CreateDatasetItem2DatasetsResponse200ApplicationJSONResponseBodyMessages4Type = Literal[
    "refusal"
]
r"""The type of the content part."""


class CreateDatasetItem2DatasetsRefusalContentPartTypedDict(TypedDict):
    type: CreateDatasetItem2DatasetsResponse200ApplicationJSONResponseBodyMessages4Type
    r"""The type of the content part."""
    refusal: str
    r"""The refusal message generated by the model."""


class CreateDatasetItem2DatasetsRefusalContentPart(BaseModel):
    type: CreateDatasetItem2DatasetsResponse200ApplicationJSONResponseBodyMessages4Type
    r"""The type of the content part."""

    refusal: str
    r"""The refusal message generated by the model."""


CreateDatasetItem2DatasetsResponse200ApplicationJSONResponseBodyMessagesType = Literal[
    "text"
]
r"""The type of the content part."""


class CreateDatasetItem2DatasetsTextContentPartTypedDict(TypedDict):
    type: CreateDatasetItem2DatasetsResponse200ApplicationJSONResponseBodyMessagesType
    r"""The type of the content part."""
    text: str
    r"""The text content."""


class CreateDatasetItem2DatasetsTextContentPart(BaseModel):
    type: CreateDatasetItem2DatasetsResponse200ApplicationJSONResponseBodyMessagesType
    r"""The type of the content part."""

    text: str
    r"""The text content."""


CreateDatasetItemContentDatasetsResponse2002TypedDict = TypeAliasType(
    "CreateDatasetItemContentDatasetsResponse2002TypedDict",
    Union[
        CreateDatasetItem2DatasetsTextContentPartTypedDict,
        CreateDatasetItem2DatasetsRefusalContentPartTypedDict,
    ],
)


CreateDatasetItemContentDatasetsResponse2002 = TypeAliasType(
    "CreateDatasetItemContentDatasetsResponse2002",
    Union[
        CreateDatasetItem2DatasetsTextContentPart,
        CreateDatasetItem2DatasetsRefusalContentPart,
    ],
)


CreateDatasetItemMessagesDatasetsResponse200ContentTypedDict = TypeAliasType(
    "CreateDatasetItemMessagesDatasetsResponse200ContentTypedDict",
    Union[str, List[CreateDatasetItemContentDatasetsResponse2002TypedDict]],
)
r"""The contents of the assistant message. Required unless `tool_calls` or `function_call` is specified."""


CreateDatasetItemMessagesDatasetsResponse200Content = TypeAliasType(
    "CreateDatasetItemMessagesDatasetsResponse200Content",
    Union[str, List[CreateDatasetItemContentDatasetsResponse2002]],
)
r"""The contents of the assistant message. Required unless `tool_calls` or `function_call` is specified."""


CreateDatasetItemMessagesDatasetsResponse200ApplicationJSONResponseBodyRole = Literal[
    "assistant"
]
r"""The role of the messages author, in this case `assistant`."""


class CreateDatasetItemMessagesDatasetsAudioTypedDict(TypedDict):
    r"""Data about a previous audio response from the model."""

    id: str
    r"""Unique identifier for a previous audio response from the model."""


class CreateDatasetItemMessagesDatasetsAudio(BaseModel):
    r"""Data about a previous audio response from the model."""

    id: str
    r"""Unique identifier for a previous audio response from the model."""


CreateDatasetItemMessagesDatasetsType = Literal["function"]
r"""The type of the tool. Currently, only `function` is supported."""


class CreateDatasetItemMessagesDatasetsFunctionTypedDict(TypedDict):
    name: NotRequired[str]
    r"""The name of the function to call."""
    arguments: NotRequired[str]
    r"""The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function."""


class CreateDatasetItemMessagesDatasetsFunction(BaseModel):
    name: Optional[str] = None
    r"""The name of the function to call."""

    arguments: Optional[str] = None
    r"""The arguments to call the function with, as generated by the model in JSON format. Note that the model does not always generate valid JSON, and may hallucinate parameters not defined by your function schema. Validate the arguments in your code before calling your function."""


class CreateDatasetItemMessagesDatasetsToolCallsTypedDict(TypedDict):
    id: str
    r"""The ID of the tool call."""
    type: CreateDatasetItemMessagesDatasetsType
    r"""The type of the tool. Currently, only `function` is supported."""
    function: CreateDatasetItemMessagesDatasetsFunctionTypedDict


class CreateDatasetItemMessagesDatasetsToolCalls(BaseModel):
    id: str
    r"""The ID of the tool call."""

    type: CreateDatasetItemMessagesDatasetsType
    r"""The type of the tool. Currently, only `function` is supported."""

    function: CreateDatasetItemMessagesDatasetsFunction


class CreateDatasetItemMessagesDatasetsAssistantMessageTypedDict(TypedDict):
    role: CreateDatasetItemMessagesDatasetsResponse200ApplicationJSONResponseBodyRole
    r"""The role of the messages author, in this case `assistant`."""
    content: NotRequired[
        Nullable[CreateDatasetItemMessagesDatasetsResponse200ContentTypedDict]
    ]
    r"""The contents of the assistant message. Required unless `tool_calls` or `function_call` is specified."""
    refusal: NotRequired[Nullable[str]]
    r"""The refusal message by the assistant."""
    name: NotRequired[str]
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""
    audio: NotRequired[Nullable[CreateDatasetItemMessagesDatasetsAudioTypedDict]]
    r"""Data about a previous audio response from the model."""
    tool_calls: NotRequired[List[CreateDatasetItemMessagesDatasetsToolCallsTypedDict]]
    r"""The tool calls generated by the model, such as function calls."""
    reasoning: NotRequired[str]
    r"""Internal thought process of the model"""
    reasoning_signature: NotRequired[str]
    r"""The signature holds a cryptographic token which verifies that the thinking block was generated by the model, and is verified when thinking is part of a multiturn conversation. This value should not be modified and should always be sent to the API when the reasoning is redacted. Currently only supported by `Anthropic`."""
    redacted_reasoning: NotRequired[str]
    r"""Occasionally the model's internal reasoning will be flagged by the safety systems of the provider. When this occurs, the provider will encrypt the reasoning. These redacted reasoning is decrypted when passed back to the API, allowing the model to continue its response without losing context."""


class CreateDatasetItemMessagesDatasetsAssistantMessage(BaseModel):
    role: CreateDatasetItemMessagesDatasetsResponse200ApplicationJSONResponseBodyRole
    r"""The role of the messages author, in this case `assistant`."""

    content: OptionalNullable[CreateDatasetItemMessagesDatasetsResponse200Content] = (
        UNSET
    )
    r"""The contents of the assistant message. Required unless `tool_calls` or `function_call` is specified."""

    refusal: OptionalNullable[str] = UNSET
    r"""The refusal message by the assistant."""

    name: Optional[str] = None
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""

    audio: OptionalNullable[CreateDatasetItemMessagesDatasetsAudio] = UNSET
    r"""Data about a previous audio response from the model."""

    tool_calls: Optional[List[CreateDatasetItemMessagesDatasetsToolCalls]] = None
    r"""The tool calls generated by the model, such as function calls."""

    reasoning: Optional[str] = None
    r"""Internal thought process of the model"""

    reasoning_signature: Optional[str] = None
    r"""The signature holds a cryptographic token which verifies that the thinking block was generated by the model, and is verified when thinking is part of a multiturn conversation. This value should not be modified and should always be sent to the API when the reasoning is redacted. Currently only supported by `Anthropic`."""

    redacted_reasoning: Optional[str] = None
    r"""Occasionally the model's internal reasoning will be flagged by the safety systems of the provider. When this occurs, the provider will encrypt the reasoning. These redacted reasoning is decrypted when passed back to the API, allowing the model to continue its response without losing context."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "content",
            "refusal",
            "name",
            "audio",
            "tool_calls",
            "reasoning",
            "reasoning_signature",
            "redacted_reasoning",
        ]
        nullable_fields = ["content", "refusal", "audio"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


CreateDatasetItemMessagesDatasetsResponse200ApplicationJSONRole = Literal["user"]
r"""The role of the messages author, in this case `user`."""

CreateDatasetItem2DatasetsResponse200ApplicationJSONResponseBodyType = Literal["file"]
r"""The type of the content part. Always `file`."""


class CreateDatasetItem2DatasetsFileTypedDict(TypedDict):
    file_data: str
    r"""The base64 encoded file data, used when passing the file to the model as a string."""
    filename: NotRequired[str]
    r"""The name of the file, used when passing the file to the model as a string."""


class CreateDatasetItem2DatasetsFile(BaseModel):
    file_data: str
    r"""The base64 encoded file data, used when passing the file to the model as a string."""

    filename: Optional[str] = None
    r"""The name of the file, used when passing the file to the model as a string."""


class CreateDatasetItem2Datasets4TypedDict(TypedDict):
    type: CreateDatasetItem2DatasetsResponse200ApplicationJSONResponseBodyType
    r"""The type of the content part. Always `file`."""
    file: CreateDatasetItem2DatasetsFileTypedDict


class CreateDatasetItem2Datasets4(BaseModel):
    type: CreateDatasetItem2DatasetsResponse200ApplicationJSONResponseBodyType
    r"""The type of the content part. Always `file`."""

    file: CreateDatasetItem2DatasetsFile


CreateDatasetItem2DatasetsResponse200ApplicationJSONType = Literal["input_audio"]

CreateDatasetItem2DatasetsFormat = Literal["mp3", "wav"]
r"""The format of the encoded audio data. Currently supports `wav` and `mp3`."""


class CreateDatasetItem2DatasetsInputAudioTypedDict(TypedDict):
    data: str
    r"""Base64 encoded audio data."""
    format_: CreateDatasetItem2DatasetsFormat
    r"""The format of the encoded audio data. Currently supports `wav` and `mp3`."""


class CreateDatasetItem2DatasetsInputAudio(BaseModel):
    data: str
    r"""Base64 encoded audio data."""

    format_: Annotated[CreateDatasetItem2DatasetsFormat, pydantic.Field(alias="format")]
    r"""The format of the encoded audio data. Currently supports `wav` and `mp3`."""


class CreateDatasetItem2Datasets3TypedDict(TypedDict):
    type: CreateDatasetItem2DatasetsResponse200ApplicationJSONType
    input_audio: CreateDatasetItem2DatasetsInputAudioTypedDict


class CreateDatasetItem2Datasets3(BaseModel):
    type: CreateDatasetItem2DatasetsResponse200ApplicationJSONType

    input_audio: CreateDatasetItem2DatasetsInputAudio


CreateDatasetItem2DatasetsResponse200Type = Literal["image_url"]

CreateDatasetItem2DatasetsDetail = Literal["low", "high", "auto"]
r"""Specifies the detail level of the image."""


class CreateDatasetItem2DatasetsImageURLTypedDict(TypedDict):
    url: str
    r"""Either a URL of the image or the base64 encoded image data."""
    detail: NotRequired[CreateDatasetItem2DatasetsDetail]
    r"""Specifies the detail level of the image."""


class CreateDatasetItem2DatasetsImageURL(BaseModel):
    url: str
    r"""Either a URL of the image or the base64 encoded image data."""

    detail: Optional[CreateDatasetItem2DatasetsDetail] = None
    r"""Specifies the detail level of the image."""


class CreateDatasetItem2Datasets2TypedDict(TypedDict):
    type: CreateDatasetItem2DatasetsResponse200Type
    image_url: CreateDatasetItem2DatasetsImageURLTypedDict


class CreateDatasetItem2Datasets2(BaseModel):
    type: CreateDatasetItem2DatasetsResponse200Type

    image_url: CreateDatasetItem2DatasetsImageURL


CreateDatasetItem2DatasetsResponseType = Literal["text"]


class CreateDatasetItem2Datasets1TypedDict(TypedDict):
    type: CreateDatasetItem2DatasetsResponseType
    text: str


class CreateDatasetItem2Datasets1(BaseModel):
    type: CreateDatasetItem2DatasetsResponseType

    text: str


CreateDatasetItemContentDatasetsResponse2TypedDict = TypeAliasType(
    "CreateDatasetItemContentDatasetsResponse2TypedDict",
    Union[
        CreateDatasetItem2Datasets1TypedDict,
        CreateDatasetItem2Datasets2TypedDict,
        CreateDatasetItem2Datasets3TypedDict,
        CreateDatasetItem2Datasets4TypedDict,
    ],
)


CreateDatasetItemContentDatasetsResponse2 = TypeAliasType(
    "CreateDatasetItemContentDatasetsResponse2",
    Union[
        CreateDatasetItem2Datasets1,
        CreateDatasetItem2Datasets2,
        CreateDatasetItem2Datasets3,
        CreateDatasetItem2Datasets4,
    ],
)


CreateDatasetItemMessagesDatasetsResponseContentTypedDict = TypeAliasType(
    "CreateDatasetItemMessagesDatasetsResponseContentTypedDict",
    Union[str, List[CreateDatasetItemContentDatasetsResponse2TypedDict]],
)
r"""The contents of the user message."""


CreateDatasetItemMessagesDatasetsResponseContent = TypeAliasType(
    "CreateDatasetItemMessagesDatasetsResponseContent",
    Union[str, List[CreateDatasetItemContentDatasetsResponse2]],
)
r"""The contents of the user message."""


class CreateDatasetItemMessagesDatasetsUserMessageTypedDict(TypedDict):
    role: CreateDatasetItemMessagesDatasetsResponse200ApplicationJSONRole
    r"""The role of the messages author, in this case `user`."""
    content: CreateDatasetItemMessagesDatasetsResponseContentTypedDict
    r"""The contents of the user message."""
    name: NotRequired[str]
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


class CreateDatasetItemMessagesDatasetsUserMessage(BaseModel):
    role: CreateDatasetItemMessagesDatasetsResponse200ApplicationJSONRole
    r"""The role of the messages author, in this case `user`."""

    content: CreateDatasetItemMessagesDatasetsResponseContent
    r"""The contents of the user message."""

    name: Optional[str] = None
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


CreateDatasetItemMessagesDatasetsResponse200Role = Literal["system"]
r"""The role of the messages author, in this case `system`."""


class CreateDatasetItemMessagesDatasetsSystemMessageTypedDict(TypedDict):
    role: CreateDatasetItemMessagesDatasetsResponse200Role
    r"""The role of the messages author, in this case `system`."""
    content: str
    r"""The contents of the system message."""
    name: NotRequired[str]
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


class CreateDatasetItemMessagesDatasetsSystemMessage(BaseModel):
    role: CreateDatasetItemMessagesDatasetsResponse200Role
    r"""The role of the messages author, in this case `system`."""

    content: str
    r"""The contents of the system message."""

    name: Optional[str] = None
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


CreateDatasetItemMessagesDatasetsResponseRole = Literal["developer"]
r"""The role of the messages author, in this case  `developer`."""


class CreateDatasetItemMessagesDatasetsDeveloperMessageTypedDict(TypedDict):
    role: CreateDatasetItemMessagesDatasetsResponseRole
    r"""The role of the messages author, in this case  `developer`."""
    content: str
    r"""The contents of the developer message."""
    name: NotRequired[str]
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


class CreateDatasetItemMessagesDatasetsDeveloperMessage(BaseModel):
    role: CreateDatasetItemMessagesDatasetsResponseRole
    r"""The role of the messages author, in this case  `developer`."""

    content: str
    r"""The contents of the developer message."""

    name: Optional[str] = None
    r"""An optional name for the participant. Provides the model information to differentiate between participants of the same role."""


CreateDatasetItemDatasetsMessagesTypedDict = TypeAliasType(
    "CreateDatasetItemDatasetsMessagesTypedDict",
    Union[
        CreateDatasetItemMessagesDatasetsDeveloperMessageTypedDict,
        CreateDatasetItemMessagesDatasetsSystemMessageTypedDict,
        CreateDatasetItemMessagesDatasetsUserMessageTypedDict,
        CreateDatasetItemMessagesDatasetsToolMessageTypedDict,
        CreateDatasetItemMessagesDatasetsAssistantMessageTypedDict,
    ],
)


CreateDatasetItemDatasetsMessages = TypeAliasType(
    "CreateDatasetItemDatasetsMessages",
    Union[
        CreateDatasetItemMessagesDatasetsDeveloperMessage,
        CreateDatasetItemMessagesDatasetsSystemMessage,
        CreateDatasetItemMessagesDatasetsUserMessage,
        CreateDatasetItemMessagesDatasetsToolMessage,
        CreateDatasetItemMessagesDatasetsAssistantMessage,
    ],
)


class CreateDatasetItemResponseBodyTypedDict(TypedDict):
    r"""Datapoint created successfully. Returns the newly created datapoint object."""

    id: str
    r"""The unique identifier of the dataset item"""
    workspace_id: str
    r"""The unique identifier of the workspace it belongs to"""
    dataset_id: str
    r"""The unique identifier of the dataset"""
    inputs: NotRequired[Dict[str, Any]]
    r"""The inputs of the dataset. Key value pairs where the key is the input name and the value is the input value. Nested objects are not supported."""
    messages: NotRequired[List[CreateDatasetItemDatasetsMessagesTypedDict]]
    r"""A list of messages comprising the conversation so far"""
    expected_output: NotRequired[str]
    created_by_id: NotRequired[str]
    r"""The unique identifier of the user who created the dataset"""
    updated_by_id: NotRequired[str]
    r"""The unique identifier of the user who last updated the dataset"""
    created: NotRequired[datetime]
    r"""The date and time the resource was created"""
    updated: NotRequired[datetime]
    r"""The date and time the resource was last updated"""


class CreateDatasetItemResponseBody(BaseModel):
    r"""Datapoint created successfully. Returns the newly created datapoint object."""

    id: Annotated[str, pydantic.Field(alias="_id")]
    r"""The unique identifier of the dataset item"""

    workspace_id: str
    r"""The unique identifier of the workspace it belongs to"""

    dataset_id: str
    r"""The unique identifier of the dataset"""

    inputs: Optional[Dict[str, Any]] = None
    r"""The inputs of the dataset. Key value pairs where the key is the input name and the value is the input value. Nested objects are not supported."""

    messages: Optional[List[CreateDatasetItemDatasetsMessages]] = None
    r"""A list of messages comprising the conversation so far"""

    expected_output: Optional[str] = None

    created_by_id: Optional[str] = None
    r"""The unique identifier of the user who created the dataset"""

    updated_by_id: Optional[str] = None
    r"""The unique identifier of the user who last updated the dataset"""

    created: Optional[datetime] = None
    r"""The date and time the resource was created"""

    updated: Optional[datetime] = parse_datetime("2025-06-04T07:24:10.431Z")
    r"""The date and time the resource was last updated"""
